summaryrefslogtreecommitdiff
path: root/src/share/common
blob: e735319800f36930fa26c0d488d59534254f4811 (plain)
  1. # -*-shell-script-*-
  2. # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
  3. # Shared sh functions for the monkeysphere
  4. #
  5. # Written by
  6. # Jameson Rollins <jrollins@finestructure.net>
  7. # Jamie McClelland <jm@mayfirst.org>
  8. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  9. #
  10. # Copyright 2008-2009, released under the GPL, version 3 or later
  11. # all-caps variables are meant to be user supplied (ie. from config
  12. # file) and are considered global
  13. ########################################################################
  14. ### UTILITY FUNCTIONS
  15. # output version info
  16. version() {
  17. cat "${SYSSHAREDIR}/VERSION"
  18. }
  19. # failure function. exits with code 255, unless specified otherwise.
  20. failure() {
  21. [ "$1" ] && echo "$1" >&2
  22. exit ${2:-'255'}
  23. }
  24. # write output to stderr based on specified LOG_LEVEL the first
  25. # parameter is the priority of the output, and everything else is what
  26. # is echoed to stderr. If there is nothing else, then output comes
  27. # from stdin, and is not prefaced by log prefix.
  28. log() {
  29. local priority
  30. local level
  31. local output
  32. local alllevels
  33. local found=
  34. # don't include SILENT in alllevels: it's handled separately
  35. # list in decreasing verbosity (all caps).
  36. # separate with $IFS explicitly, since we do some fancy footwork
  37. # elsewhere.
  38. alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
  39. # translate lowers to uppers in global log level
  40. LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
  41. # just go ahead and return if the log level is silent
  42. if [ "$LOG_LEVEL" = 'SILENT' ] ; then
  43. return
  44. fi
  45. for level in $alllevels ; do
  46. if [ "$LOG_LEVEL" = "$level" ] ; then
  47. found=true
  48. fi
  49. done
  50. if [ -z "$found" ] ; then
  51. # default to INFO:
  52. LOG_LEVEL=INFO
  53. fi
  54. # get priority from first parameter, translating all lower to
  55. # uppers
  56. priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
  57. shift
  58. # scan over available levels
  59. for level in $alllevels ; do
  60. # output if the log level matches, set output to true
  61. # this will output for all subsequent loops as well.
  62. if [ "$LOG_LEVEL" = "$level" ] ; then
  63. output=true
  64. fi
  65. if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
  66. if [ "$1" ] ; then
  67. echo "$@"
  68. else
  69. cat
  70. fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
  71. fi
  72. done
  73. }
  74. # run command as monkeysphere user
  75. su_monkeysphere_user() {
  76. # our main goal here is to run the given command as the the
  77. # monkeysphere user, but without prompting for any sort of
  78. # authentication. If this is not possible, we should just fail.
  79. # FIXME: our current implementation is overly restrictive, because
  80. # there may be some su PAM configurations that would allow su
  81. # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
  82. # allowing specific users to invoke commands which make use of
  83. # this user.
  84. # chpst (from runit) would be nice to use, but we don't want to
  85. # introduce an extra dependency just for this. This may be a
  86. # candidate for re-factoring if we switch implementation languages.
  87. case $(id -un) in
  88. # if monkeysphere user, run the command under bash
  89. "$MONKEYSPHERE_USER")
  90. bash -c "$@"
  91. ;;
  92. # if root, su command as monkeysphere user
  93. 'root')
  94. su "$MONKEYSPHERE_USER" -c "$@"
  95. ;;
  96. # otherwise, fail
  97. *)
  98. log error "non-privileged user."
  99. ;;
  100. esac
  101. }
  102. # cut out all comments(#) and blank lines from standard input
  103. meat() {
  104. grep -v -e "^[[:space:]]*#" -e '^$' "$1"
  105. }
  106. # cut a specified line from standard input
  107. cutline() {
  108. head --line="$1" "$2" | tail -1
  109. }
  110. # make a temporary directory
  111. msmktempdir() {
  112. mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  113. }
  114. # make a temporary file
  115. msmktempfile() {
  116. mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  117. }
  118. # this is a wrapper for doing lock functions.
  119. #
  120. # it lets us depend on either lockfile-progs (preferred) or procmail's
  121. # lockfile, and should
  122. lock() {
  123. local use_lockfileprogs=true
  124. local action="$1"
  125. local file="$2"
  126. if ! ( type lockfile-create &>/dev/null ) ; then
  127. if ! ( type lockfile &>/dev/null ); then
  128. failure "Neither lockfile-create nor lockfile are in the path!"
  129. fi
  130. use_lockfileprogs=
  131. fi
  132. case "$action" in
  133. create)
  134. if [ -n "$use_lockfileprogs" ] ; then
  135. lockfile-create "$file" || failure "unable to lock '$file'"
  136. else
  137. lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
  138. fi
  139. log debug "lock created on '$file'."
  140. ;;
  141. touch)
  142. if [ -n "$use_lockfileprogs" ] ; then
  143. lockfile-touch --oneshot "$file"
  144. else
  145. : Nothing to do here
  146. fi
  147. log debug "lock touched on '$file'."
  148. ;;
  149. remove)
  150. if [ -n "$use_lockfileprogs" ] ; then
  151. lockfile-remove "$file"
  152. else
  153. rm -f "${file}.lock"
  154. fi
  155. log debug "lock removed on '$file'."
  156. ;;
  157. *)
  158. failure "bad argument for lock subfunction '$action'"
  159. esac
  160. }
  161. # for portability, between gnu date and BSD date.
  162. # arguments should be: number longunits format
  163. # e.g. advance_date 20 seconds +%F
  164. advance_date() {
  165. local gnutry
  166. local number="$1"
  167. local longunits="$2"
  168. local format="$3"
  169. local shortunits
  170. # try things the GNU way first
  171. if date -d "$number $longunits" "$format" &>/dev/null; then
  172. date -d "$number $longunits" "$format"
  173. else
  174. # otherwise, convert to (a limited version of) BSD date syntax:
  175. case "$longunits" in
  176. years)
  177. shortunits=y
  178. ;;
  179. months)
  180. shortunits=m
  181. ;;
  182. weeks)
  183. shortunits=w
  184. ;;
  185. days)
  186. shortunits=d
  187. ;;
  188. hours)
  189. shortunits=H
  190. ;;
  191. minutes)
  192. shortunits=M
  193. ;;
  194. seconds)
  195. shortunits=S
  196. ;;
  197. *)
  198. # this is a longshot, and will likely fail; oh well.
  199. shortunits="$longunits"
  200. esac
  201. date "-v+${number}${shortunits}" "$format"
  202. fi
  203. }
  204. # check that characters are in a string (in an AND fashion).
  205. # used for checking key capability
  206. # check_capability capability a [b...]
  207. check_capability() {
  208. local usage
  209. local capcheck
  210. usage="$1"
  211. shift 1
  212. for capcheck ; do
  213. if echo "$usage" | grep -q -v "$capcheck" ; then
  214. return 1
  215. fi
  216. done
  217. return 0
  218. }
  219. # hash of a file
  220. file_hash() {
  221. if type md5sum &>/dev/null ; then
  222. md5sum "$1"
  223. elif type md5 &>/dev/null ; then
  224. md5 "$1"
  225. else
  226. failure "Neither md5sum nor md5 are in the path!"
  227. fi
  228. }
  229. # convert escaped characters in pipeline from gpg output back into
  230. # original character
  231. # FIXME: undo all escape character translation in with-colons gpg
  232. # output
  233. gpg_unescape() {
  234. sed 's/\\x3a/:/g'
  235. }
  236. # convert nasty chars into gpg-friendly form in pipeline
  237. # FIXME: escape everything, not just colons!
  238. gpg_escape() {
  239. sed 's/:/\\x3a/g'
  240. }
  241. # prompt for GPG-formatted expiration, and emit result on stdout
  242. get_gpg_expiration() {
  243. local keyExpire
  244. keyExpire="$1"
  245. if [ -z "$keyExpire" -a "$PROMPT" != 'false' ]; then
  246. cat >&2 <<EOF
  247. Please specify how long the key should be valid.
  248. 0 = key does not expire
  249. <n> = key expires in n days
  250. <n>w = key expires in n weeks
  251. <n>m = key expires in n months
  252. <n>y = key expires in n years
  253. EOF
  254. while [ -z "$keyExpire" ] ; do
  255. printf "Key is valid for? (0) " >&2
  256. read keyExpire
  257. if ! test_gpg_expire ${keyExpire:=0} ; then
  258. echo "invalid value" >&2
  259. unset keyExpire
  260. fi
  261. done
  262. elif ! test_gpg_expire "$keyExpire" ; then
  263. failure "invalid key expiration value '$keyExpire'."
  264. fi
  265. echo "$keyExpire"
  266. }
  267. passphrase_prompt() {
  268. local prompt="$1"
  269. local fifo="$2"
  270. local PASS
  271. if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null 2>/dev/null; then
  272. printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
  273. printf '(with prompt "%s")\n' "$prompt" | log debug
  274. "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
  275. else
  276. read -s -p "$prompt" PASS
  277. # Uses the builtin echo, so should not put the passphrase into
  278. # the process table. I think. --dkg
  279. echo "$PASS" > "$fifo"
  280. fi
  281. }
  282. # remove all lines with specified string from specified file
  283. remove_line() {
  284. local file
  285. local string
  286. local tempfile
  287. file="$1"
  288. string="$2"
  289. if [ -z "$file" -o -z "$string" ] ; then
  290. return 1
  291. fi
  292. if [ ! -e "$file" ] ; then
  293. return 1
  294. fi
  295. # if the string is in the file...
  296. if grep -q -F "$string" "$file" 2>/dev/null ; then
  297. tempfile=$(mktemp "${file}.XXXXXXX") || \
  298. failure "Unable to make temp file '${file}.XXXXXXX'"
  299. # remove the line with the string, and return 0
  300. grep -v -F "$string" "$file" >"$tempfile"
  301. cat "$tempfile" > "$file"
  302. rm "$tempfile"
  303. return 0
  304. # otherwise return 1
  305. else
  306. return 1
  307. fi
  308. }
  309. # remove all lines with MonkeySphere strings in file
  310. remove_monkeysphere_lines() {
  311. local file
  312. local tempfile
  313. file="$1"
  314. # return error if file does not exist
  315. if [ ! -e "$file" ] ; then
  316. return 1
  317. fi
  318. # just return ok if the file is empty, since there aren't any
  319. # lines to remove
  320. if [ ! -s "$file" ] ; then
  321. return 0
  322. fi
  323. tempfile=$(mktemp "${file}.XXXXXXX") || \
  324. failure "Could not make temporary file '${file}.XXXXXXX'."
  325. egrep -v '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$' \
  326. "$file" >"$tempfile"
  327. cat "$tempfile" > "$file"
  328. rm "$tempfile"
  329. }
  330. # translate ssh-style path variables %h and %u
  331. translate_ssh_variables() {
  332. local uname
  333. local home
  334. uname="$1"
  335. path="$2"
  336. # get the user's home directory
  337. userHome=$(get_homedir "$uname")
  338. # translate '%u' to user name
  339. path=${path/\%u/"$uname"}
  340. # translate '%h' to user home directory
  341. path=${path/\%h/"$userHome"}
  342. echo "$path"
  343. }
  344. # test that a string to conforms to GPG's expiration format
  345. test_gpg_expire() {
  346. echo "$1" | egrep -q "^[0-9]+[mwy]?$"
  347. }
  348. # check that a file is properly owned, and that all it's parent
  349. # directories are not group/other writable
  350. check_key_file_permissions() {
  351. local uname
  352. local path
  353. uname="$1"
  354. path="$2"
  355. if [ "$STRICT_MODES" = 'false' ] ; then
  356. log debug "skipping path permission check for '$path' because STRICT_MODES is false..."
  357. return 0
  358. fi
  359. log debug "checking path permission '$path'..."
  360. "${SYSSHAREDIR}/checkperms" "$uname" "$path"
  361. }
  362. # return a list of all users on the system
  363. list_users() {
  364. if type getent &>/dev/null ; then
  365. # for linux and FreeBSD systems
  366. getent passwd | cut -d: -f1
  367. elif type dscl &>/dev/null ; then
  368. # for Darwin systems
  369. dscl localhost -list /Search/Users
  370. else
  371. failure "Neither getent or dscl is in the path! Could not determine list of users."
  372. fi
  373. }
  374. # take one argument, a service name. in response, print a series of
  375. # lines, each with a unique numeric port number that might be
  376. # associated with that service name. (e.g. in: "https", out: "443")
  377. # if nothing is found, print nothing, and return 0.
  378. #
  379. # return 1 if there was an error in the search somehow
  380. get_port_for_service() {
  381. [[ "$1" =~ ^[a-z0-9]([a-z0-9-]*[a-z0-9])?$ ]] || \
  382. failure $(printf "This is not a valid service name: '%s'" "$1")
  383. if type getent &>/dev/null ; then
  384. # for linux and FreeBSD systems (getent returns 2 if not found, 0 on success, 1 or 3 on various failures)
  385. (getent services "$service" || if [ "$?" -eq 2 ] ; then true ; else false; fi) | awk '{ print $2 }' | cut -f1 -d/ | sort -u
  386. elif [ -r /etc/services ] ; then
  387. # fall back to /etc/services for systems that don't have getent (MacOS?)
  388. # FIXME: doesn't handle aliases like "null" (or "http"?), which don't show up at the beginning of the line.
  389. awk $(printf '/^%s[[:space:]]/{ print $2 }' "$1") /etc/services | cut -f1 -d/ | sort -u
  390. else
  391. return 1
  392. fi
  393. }
  394. # return the path to the home directory of a user
  395. get_homedir() {
  396. local uname=${1:-`whoami`}
  397. eval "echo ~${uname}"
  398. }
  399. # return the primary group of a user
  400. get_primary_group() {
  401. local uname=${1:-`whoami`}
  402. groups "$uname" | sed 's/^..* : //' | awk '{ print $1 }'
  403. }
  404. ### CONVERSION UTILITIES
  405. # output the ssh key for a given key ID
  406. gpg2ssh() {
  407. local keyID
  408. keyID="$1"
  409. gpg --export "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
  410. }
  411. # output known_hosts line from ssh key
  412. ssh2known_hosts() {
  413. local host
  414. local port
  415. local key
  416. # FIXME this does not properly deal with IPv6 hosts using the
  417. # standard port (because it's unclear whether their final
  418. # colon-delimited address section is a port number or an address
  419. # string)
  420. host=${1%:*}
  421. port=${1##*:}
  422. key="$2"
  423. # specify the host and port properly for new ssh known_hosts
  424. # format
  425. if [ "$port" != "$host" ] ; then
  426. host="[${host}]:${port}"
  427. fi
  428. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  429. }
  430. # output authorized_keys line from ssh key
  431. ssh2authorized_keys() {
  432. local userID
  433. local key
  434. userID="$1"
  435. key="$2"
  436. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  437. }
  438. # convert key from gpg to ssh known_hosts format
  439. gpg2known_hosts() {
  440. local host
  441. local keyID
  442. local key
  443. host="$1"
  444. keyID="$2"
  445. key=$(gpg2ssh "$keyID")
  446. # NOTE: it seems that ssh-keygen -R removes all comment fields from
  447. # all lines in the known_hosts file. why?
  448. # NOTE: just in case, the COMMENT can be matched with the
  449. # following regexp:
  450. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  451. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  452. }
  453. # convert key from gpg to ssh authorized_keys format
  454. gpg2authorized_keys() {
  455. local userID
  456. local keyID
  457. local key
  458. userID="$1"
  459. keyID="$2"
  460. key=$(gpg2ssh "$keyID")
  461. # NOTE: just in case, the COMMENT can be matched with the
  462. # following regexp:
  463. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  464. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  465. }
  466. ### GPG UTILITIES
  467. # script to determine if gpg version is equal to or greater than specified version
  468. is_gpg_version_greater_equal() {
  469. local gpgVersion=$(gpg --version | head -1 | awk '{ print $3 }')
  470. local latest=$(printf '%s\n%s\n' "$1" "$gpgVersion" \
  471. | tr '.' ' ' | sort -g -k1 -k2 -k3 \
  472. | tail -1 | tr ' ' '.')
  473. [[ "$gpgVersion" == "$latest" ]]
  474. }
  475. # retrieve all keys with given user id from keyserver
  476. # FIXME: need to figure out how to retrieve all matching keys
  477. # (not just first N (5 in this case))
  478. gpg_fetch_userid() {
  479. local returnCode=0
  480. local userID
  481. if [ "$CHECK_KEYSERVER" != 'true' ] ; then
  482. return 0
  483. fi
  484. userID="$1"
  485. log verbose " checking keyserver $KEYSERVER... "
  486. echo 1,2,3,4,5 | \
  487. gpg --quiet --batch --with-colons \
  488. --command-fd 0 --keyserver "$KEYSERVER" \
  489. --search ="$userID" &>/dev/null
  490. returnCode="$?"
  491. return "$returnCode"
  492. }
  493. ########################################################################
  494. ### PROCESSING FUNCTIONS
  495. # userid and key policy checking
  496. # the following checks policy on the returned keys
  497. # - checks that full key has appropriate valididy (u|f)
  498. # - checks key has specified capability (REQUIRED_KEY_CAPABILITY)
  499. # - checks that requested user ID has appropriate validity
  500. # (see /usr/share/doc/gnupg/DETAILS.gz)
  501. # output is one line for every found key, in the following format:
  502. #
  503. # flag:sshKey
  504. #
  505. # "flag" is an acceptability flag, 0 = ok, 1 = bad
  506. # "sshKey" is the translated gpg key
  507. #
  508. # all log output must go to stderr, as stdout is used to pass the
  509. # flag:sshKey to the calling function.
  510. process_user_id() {
  511. local returnCode=0
  512. local userID
  513. local requiredCapability
  514. local requiredPubCapability
  515. local gpgOut
  516. local type
  517. local validity
  518. local keyid
  519. local uidfpr
  520. local usage
  521. local keyOK
  522. local uidOK
  523. local lastKey
  524. local lastKeyOK
  525. local fingerprint
  526. userID="$1"
  527. # set the required key capability based on the mode
  528. requiredCapability=${REQUIRED_KEY_CAPABILITY:="a"}
  529. requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
  530. # fetch the user ID if necessary/requested
  531. gpg_fetch_userid "$userID"
  532. # output gpg info for (exact) userid and store
  533. gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
  534. --with-fingerprint --with-fingerprint \
  535. ="$userID" 2>/dev/null) || returnCode="$?"
  536. # if the gpg query return code is not 0, return 1
  537. if [ "$returnCode" -ne 0 ] ; then
  538. log verbose " no primary keys found."
  539. return 1
  540. fi
  541. # loop over all lines in the gpg output and process.
  542. echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
  543. while IFS=: read -r type validity keyid uidfpr usage ; do
  544. # process based on record type
  545. case $type in
  546. 'pub') # primary keys
  547. # new key, wipe the slate
  548. keyOK=
  549. uidOK=
  550. lastKey=pub
  551. lastKeyOK=
  552. fingerprint=
  553. log verbose " primary key found: $keyid"
  554. # if overall key is not valid, skip
  555. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  556. log debug " - unacceptable primary key validity ($validity)."
  557. continue
  558. fi
  559. # if overall key is disabled, skip
  560. if check_capability "$usage" 'D' ; then
  561. log debug " - key disabled."
  562. continue
  563. fi
  564. # if overall key capability is not ok, skip
  565. if ! check_capability "$usage" $requiredPubCapability ; then
  566. log debug " - unacceptable primary key capability ($usage)."
  567. continue
  568. fi
  569. # mark overall key as ok
  570. keyOK=true
  571. # mark primary key as ok if capability is ok
  572. if check_capability "$usage" $requiredCapability ; then
  573. lastKeyOK=true
  574. fi
  575. ;;
  576. 'uid') # user ids
  577. if [ "$lastKey" != pub ] ; then
  578. log verbose " ! got a user ID after a sub key?! user IDs should only follow primary keys!"
  579. continue
  580. fi
  581. # if an acceptable user ID was already found, skip
  582. if [ "$uidOK" = 'true' ] ; then
  583. continue
  584. fi
  585. # if the user ID does matches...
  586. if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
  587. # and the user ID validity is ok
  588. if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
  589. # mark user ID acceptable
  590. uidOK=true
  591. else
  592. log debug " - unacceptable user ID validity ($validity)."
  593. fi
  594. else
  595. continue
  596. fi
  597. # output a line for the primary key
  598. # 0 = ok, 1 = bad
  599. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  600. log verbose " * acceptable primary key."
  601. if [ -z "$sshKey" ] ; then
  602. log error " ! primary key could not be translated (not RSA?)."
  603. else
  604. echo "0:${sshKey}"
  605. fi
  606. else
  607. log debug " - unacceptable primary key."
  608. if [ -z "$sshKey" ] ; then
  609. log debug " ! primary key could not be translated (not RSA?)."
  610. else
  611. echo "1:${sshKey}"
  612. fi
  613. fi
  614. ;;
  615. 'sub') # sub keys
  616. # unset acceptability of last key
  617. lastKey=sub
  618. lastKeyOK=
  619. fingerprint=
  620. # don't bother with sub keys if the primary key is not valid
  621. if [ "$keyOK" != true ] ; then
  622. continue
  623. fi
  624. # don't bother with sub keys if no user ID is acceptable:
  625. if [ "$uidOK" != true ] ; then
  626. continue
  627. fi
  628. # if sub key validity is not ok, skip
  629. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  630. log debug " - unacceptable sub key validity ($validity)."
  631. continue
  632. fi
  633. # if sub key capability is not ok, skip
  634. if ! check_capability "$usage" $requiredCapability ; then
  635. log debug " - unacceptable sub key capability ($usage)."
  636. continue
  637. fi
  638. # mark sub key as ok
  639. lastKeyOK=true
  640. ;;
  641. 'fpr') # key fingerprint
  642. fingerprint="$uidfpr"
  643. sshKey=$(gpg2ssh "$fingerprint")
  644. # if the last key was the pub key, skip
  645. if [ "$lastKey" = pub ] ; then
  646. continue
  647. fi
  648. # output a line for the sub key
  649. # 0 = ok, 1 = bad
  650. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  651. log verbose " * acceptable sub key."
  652. if [ -z "$sshKey" ] ; then
  653. log error " ! sub key could not be translated (not RSA?)."
  654. else
  655. echo "0:${sshKey}"
  656. fi
  657. else
  658. log debug " - unacceptable sub key."
  659. if [ -z "$sshKey" ] ; then
  660. log debug " ! sub key could not be translated (not RSA?)."
  661. else
  662. echo "1:${sshKey}"
  663. fi
  664. fi
  665. ;;
  666. esac
  667. done | sort -t: -k1 -n -r
  668. # NOTE: this last sort is important so that the "good" keys (key
  669. # flag '0') come last. This is so that they take precedence when
  670. # being processed in the key files over "bad" keys (key flag '1')
  671. }
  672. # output all valid keys for specified user ID literal
  673. keys_for_userid() {
  674. local userID
  675. local noKey=
  676. local nKeys
  677. local nKeysOK
  678. local ok
  679. local sshKey
  680. local tmpfile
  681. userID="$1"
  682. log verbose "processing: $userID"
  683. nKeys=0
  684. nKeysOK=0
  685. IFS=$'\n'
  686. for line in $(process_user_id "${userID}") ; do
  687. # note that key was found
  688. nKeys=$((nKeys+1))
  689. ok=$(echo "$line" | cut -d: -f1)
  690. sshKey=$(echo "$line" | cut -d: -f2)
  691. if [ -z "$sshKey" ] ; then
  692. continue
  693. fi
  694. # if key OK, output key to stdout
  695. if [ "$ok" -eq '0' ] ; then
  696. # note that key was found ok
  697. nKeysOK=$((nKeysOK+1))
  698. printf '%s\n' "$sshKey"
  699. fi
  700. done
  701. # if at least one key was found...
  702. if [ "$nKeys" -gt 0 ] ; then
  703. # if ok keys were found, return 0
  704. if [ "$nKeysOK" -gt 0 ] ; then
  705. return 0
  706. # else return 2
  707. else
  708. return 2
  709. fi
  710. # if no keys were found, return 1
  711. else
  712. return 1
  713. fi
  714. }
  715. # process a single host in the known_host file
  716. process_host_known_hosts() {
  717. local host
  718. local userID
  719. local noKey=
  720. local nKeys
  721. local nKeysOK
  722. local ok
  723. local sshKey
  724. local tmpfile
  725. # set the key processing mode
  726. export REQUIRED_KEY_CAPABILITY="$REQUIRED_HOST_KEY_CAPABILITY"
  727. host="$1"
  728. userID="ssh://${host}"
  729. log verbose "processing: $host"
  730. nKeys=0
  731. nKeysOK=0
  732. IFS=$'\n'
  733. for line in $(process_user_id "${userID}") ; do
  734. # note that key was found
  735. nKeys=$((nKeys+1))
  736. ok=$(echo "$line" | cut -d: -f1)
  737. sshKey=$(echo "$line" | cut -d: -f2)
  738. if [ -z "$sshKey" ] ; then
  739. continue
  740. fi
  741. # remove any old host key line, and note if removed nothing is
  742. # removed
  743. remove_line "$KNOWN_HOSTS" "$sshKey" || noKey=true
  744. # if key OK, add new host line
  745. if [ "$ok" -eq '0' ] ; then
  746. # note that key was found ok
  747. nKeysOK=$((nKeysOK+1))
  748. # hash if specified
  749. if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
  750. # FIXME: this is really hackish cause ssh-keygen won't
  751. # hash from stdin to stdout
  752. tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
  753. ssh2known_hosts "$host" "$sshKey" > "$tmpfile"
  754. ssh-keygen -H -f "$tmpfile" 2>/dev/null
  755. cat "$tmpfile" >> "$KNOWN_HOSTS"
  756. rm -f "$tmpfile" "${tmpfile}.old"
  757. else
  758. ssh2known_hosts "$host" "$sshKey" >> "$KNOWN_HOSTS"
  759. fi
  760. # log if this is a new key to the known_hosts file
  761. if [ "$noKey" ] ; then
  762. log info "* new key for $host added to known_hosts file."
  763. fi
  764. fi
  765. done
  766. # if at least one key was found...
  767. if [ "$nKeys" -gt 0 ] ; then
  768. # if ok keys were found, return 0
  769. if [ "$nKeysOK" -gt 0 ] ; then
  770. return 0
  771. # else return 2
  772. else
  773. return 2
  774. fi
  775. # if no keys were found, return 1
  776. else
  777. return 1
  778. fi
  779. }
  780. # update the known_hosts file for a set of hosts listed on command
  781. # line
  782. update_known_hosts() {
  783. local returnCode=0
  784. local nHosts
  785. local nHostsOK
  786. local nHostsBAD
  787. local fileCheck
  788. local host
  789. local newUmask
  790. # the number of hosts specified on command line
  791. nHosts="$#"
  792. nHostsOK=0
  793. nHostsBAD=0
  794. # touch the known_hosts file so that the file permission check
  795. # below won't fail upon not finding the file
  796. if [ ! -f "$KNOWN_HOSTS" ]; then
  797. # make sure to create any files or directories with the appropriate write bits turned off:
  798. newUmask=$(printf "%04o" $(( 0$(umask) | 0022 )) )
  799. [ -d $(dirname "$KNOWN_HOSTS") ] \
  800. || (umask "$newUmask" && mkdir -p -m 0700 $(dirname "$KNOWN_HOSTS") ) \
  801. || failure "Could not create path to known_hosts file '$KNOWN_HOSTS'"
  802. # make sure to create this file with the appropriate bits turned off:
  803. (umask "$newUmask" && touch "$KNOWN_HOSTS") \
  804. || failure "Unable to create known_hosts file '$KNOWN_HOSTS'"
  805. fi
  806. # check permissions on the known_hosts file path
  807. check_key_file_permissions $(whoami) "$KNOWN_HOSTS" \
  808. || failure "Bad permissions governing known_hosts file '$KNOWN_HOSTS'"
  809. # create a lockfile on known_hosts:
  810. lock create "$KNOWN_HOSTS"
  811. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  812. trap "lock remove $KNOWN_HOSTS" EXIT
  813. # note pre update file checksum
  814. fileCheck=$(file_hash "$KNOWN_HOSTS")
  815. for host ; do
  816. # process the host
  817. process_host_known_hosts "$host" || returnCode="$?"
  818. # note the result
  819. case "$returnCode" in
  820. 0)
  821. nHostsOK=$((nHostsOK+1))
  822. ;;
  823. 2)
  824. nHostsBAD=$((nHostsBAD+1))
  825. ;;
  826. esac
  827. # touch the lockfile, for good measure.
  828. lock touch "$KNOWN_HOSTS"
  829. done
  830. # remove the lockfile and the trap
  831. lock remove "$KNOWN_HOSTS"
  832. trap - EXIT
  833. # note if the known_hosts file was updated
  834. if [ "$(file_hash "$KNOWN_HOSTS")" != "$fileCheck" ] ; then
  835. log debug "known_hosts file updated."
  836. fi
  837. # if an acceptable host was found, return 0
  838. if [ "$nHostsOK" -gt 0 ] ; then
  839. return 0
  840. # else if no ok hosts were found...
  841. else
  842. # if no bad host were found then no hosts were found at all,
  843. # and return 1
  844. if [ "$nHostsBAD" -eq 0 ] ; then
  845. return 1
  846. # else if at least one bad host was found, return 2
  847. else
  848. return 2
  849. fi
  850. fi
  851. }
  852. # process hosts from a known_hosts file
  853. process_known_hosts() {
  854. local hosts
  855. # exit if the known_hosts file does not exist
  856. if [ ! -e "$KNOWN_HOSTS" ] ; then
  857. failure "known_hosts file '$KNOWN_HOSTS' does not exist."
  858. fi
  859. log debug "processing known_hosts file:"
  860. log debug " $KNOWN_HOSTS"
  861. hosts=$(meat "$KNOWN_HOSTS" | cut -d ' ' -f 1 | grep -v '^|.*$' | tr , ' ' | tr '\n' ' ')
  862. if [ -z "$hosts" ] ; then
  863. log debug "no hosts to process."
  864. return
  865. fi
  866. # take all the hosts from the known_hosts file (first
  867. # field), grep out all the hashed hosts (lines starting
  868. # with '|')...
  869. update_known_hosts $hosts
  870. }
  871. # process uids for the authorized_keys file
  872. process_uid_authorized_keys() {
  873. local userID
  874. local nKeys
  875. local nKeysOK
  876. local ok
  877. local sshKey
  878. # set the key processing mode
  879. export REQUIRED_KEY_CAPABILITY="$REQUIRED_USER_KEY_CAPABILITY"
  880. userID="$1"
  881. log verbose "processing: $userID"
  882. nKeys=0
  883. nKeysOK=0
  884. IFS=$'\n'
  885. for line in $(process_user_id "$userID") ; do
  886. # note that key was found
  887. nKeys=$((nKeys+1))
  888. ok=$(echo "$line" | cut -d: -f1)
  889. sshKey=$(echo "$line" | cut -d: -f2)
  890. if [ -z "$sshKey" ] ; then
  891. continue
  892. fi
  893. # remove the old host key line
  894. remove_line "$AUTHORIZED_KEYS" "$sshKey"
  895. # if key OK, add new host line
  896. if [ "$ok" -eq '0' ] ; then
  897. # note that key was found ok
  898. nKeysOK=$((nKeysOK+1))
  899. ssh2authorized_keys "$userID" "$sshKey" >> "$AUTHORIZED_KEYS"
  900. fi
  901. done
  902. # if at least one key was found...
  903. if [ "$nKeys" -gt 0 ] ; then
  904. # if ok keys were found, return 0
  905. if [ "$nKeysOK" -gt 0 ] ; then
  906. return 0
  907. # else return 2
  908. else
  909. return 2
  910. fi
  911. # if no keys were found, return 1
  912. else
  913. return 1
  914. fi
  915. }
  916. # update the authorized_keys files from a list of user IDs on command
  917. # line
  918. update_authorized_keys() {
  919. local returnCode=0
  920. local userID
  921. local nIDs
  922. local nIDsOK
  923. local nIDsBAD
  924. local fileCheck
  925. # the number of ids specified on command line
  926. nIDs="$#"
  927. nIDsOK=0
  928. nIDsBAD=0
  929. log debug "updating authorized_keys file:"
  930. log debug " $AUTHORIZED_KEYS"
  931. # check permissions on the authorized_keys file path
  932. check_key_file_permissions $(whoami) "$AUTHORIZED_KEYS" || failure
  933. # create a lockfile on authorized_keys
  934. lock create "$AUTHORIZED_KEYS"
  935. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  936. trap "lock remove $AUTHORIZED_KEYS" EXIT
  937. # note pre update file checksum
  938. fileCheck="$(file_hash "$AUTHORIZED_KEYS")"
  939. # remove any monkeysphere lines from authorized_keys file
  940. remove_monkeysphere_lines "$AUTHORIZED_KEYS"
  941. for userID ; do
  942. # process the user ID, change return code if key not found for
  943. # user ID
  944. process_uid_authorized_keys "$userID" || returnCode="$?"
  945. # note the result
  946. case "$returnCode" in
  947. 0)
  948. nIDsOK=$((nIDsOK+1))
  949. ;;
  950. 2)
  951. nIDsBAD=$((nIDsBAD+1))
  952. ;;
  953. esac
  954. # touch the lockfile, for good measure.
  955. lock touch "$AUTHORIZED_KEYS"
  956. done
  957. # remove the lockfile and the trap
  958. lock remove "$AUTHORIZED_KEYS"
  959. # remove the trap
  960. trap - EXIT
  961. # note if the authorized_keys file was updated
  962. if [ "$(file_hash "$AUTHORIZED_KEYS")" != "$fileCheck" ] ; then
  963. log debug "authorized_keys file updated."
  964. fi
  965. # if an acceptable id was found, return 0
  966. if [ "$nIDsOK" -gt 0 ] ; then
  967. return 0
  968. # else if no ok ids were found...
  969. else
  970. # if no bad ids were found then no ids were found at all, and
  971. # return 1
  972. if [ "$nIDsBAD" -eq 0 ] ; then
  973. return 1
  974. # else if at least one bad id was found, return 2
  975. else
  976. return 2
  977. fi
  978. fi
  979. }
  980. # process an authorized_user_ids file for authorized_keys
  981. process_authorized_user_ids() {
  982. local line
  983. local nline
  984. local userIDs
  985. authorizedUserIDs="$1"
  986. # exit if the authorized_user_ids file is empty
  987. if [ ! -e "$authorizedUserIDs" ] ; then
  988. failure "authorized_user_ids file '$authorizedUserIDs' does not exist."
  989. fi
  990. log debug "processing authorized_user_ids file:"
  991. log debug " $authorizedUserIDs"
  992. # check permissions on the authorized_user_ids file path
  993. check_key_file_permissions $(whoami) "$authorizedUserIDs" || failure
  994. if ! meat "$authorizedUserIDs" >/dev/null ; then
  995. log debug " no user IDs to process."
  996. return
  997. fi
  998. nline=0
  999. # extract user IDs from authorized_user_ids file
  1000. IFS=$'\n'
  1001. for line in $(meat "$authorizedUserIDs") ; do
  1002. userIDs["$nline"]="$line"
  1003. nline=$((nline+1))
  1004. done
  1005. update_authorized_keys "${userIDs[@]}"
  1006. }
  1007. # takes a gpg key or keys on stdin, and outputs a list of
  1008. # fingerprints, one per line:
  1009. list_primary_fingerprints() {
  1010. local fake=$(msmktempdir)
  1011. trap "rm -rf $fake" EXIT
  1012. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  1013. GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
  1014. awk -F: '/^fpr:/{ print $10 }'
  1015. trap - EXIT
  1016. rm -rf "$fake"
  1017. }
  1018. # takes an OpenPGP key or set of keys on stdin, a fingerprint or other
  1019. # key identifier as $1, and outputs the gpg-formatted information for
  1020. # the requested keys from the material on stdin
  1021. get_cert_info() {
  1022. local fake=$(msmktempdir)
  1023. trap "rm -rf $fake" EXIT
  1024. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  1025. GNUPGHOME="$fake" gpg --with-colons --fingerprint --fixed-list-mode --list-keys "$1"
  1026. trap - EXIT
  1027. rm -rf "$fake"
  1028. }
  1029. check_cruft_file() {
  1030. local loc="$1"
  1031. local version="$2"
  1032. if [ -e "$loc" ] ; then
  1033. printf "! The file '%s' is no longer used by\n monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
  1034. fi
  1035. }
  1036. check_upgrade_dir() {
  1037. local loc="$1"
  1038. local version="$2"
  1039. if [ -d "$loc" ] ; then
  1040. printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
  1041. fi
  1042. }
  1043. ## look for cruft from old versions of the monkeysphere, and notice if
  1044. ## upgrades have not been run:
  1045. report_cruft() {
  1046. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
  1047. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
  1048. check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
  1049. check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
  1050. local found=
  1051. for foo in "${SYSDATADIR}/backup-from-"*"-transition" ; do
  1052. if [ -d "$foo" ] ; then
  1053. printf "! %s\n" "$foo" | log info
  1054. found=true
  1055. fi
  1056. done
  1057. if [ "$found" ] ; then
  1058. printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
  1059. fi
  1060. }